Name:           beagle
Version:        0.2.6
Release:        1.fc5.5
Summary:        The Beagle Search Infrastructure
Group:          User Interface/Desktops
License:        LGPL
URL:            http://beagle-project.org/
Source0:        %{name}-%{version}.tar.bz2
Source1:	beagle.desktop
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  mono-devel >= 1.1.13.5
BuildRequires:  mono-data mono-data-sqlite
BuildRequires:  gtk-sharp2-gapi mono-web zip libexif-devel
BuildRequires:  gsf-sharp >= 0.6
BuildRequires:  sqlite-devel > 3.3.1
BuildRequires:  gmime-sharp >= 2.1.19
BuildRequires:  evolution-sharp >= 0.10.2-3
BuildRequires:  libXScrnSaver-devel
BuildRequires:  gnome-vfs2-devel
BuildRequires:  libgnome-devel
BuildRequires:  gtk2-devel >= 2.6.0
BuildRequires:  librsvg2-devel >= 2.0
BuildRequires:  pygtk2-devel
BuildRequires:  python-devel
BuildRequires:  libXt-devel
BuildRequires:  gettext
Requires: sqlite >= 3.3.1
Requires: mono-core >= 1.1.13.5
Requires: zip unzip sed grep poppler-utils
Patch2: beagle-0.2.5-crawl.patch
Patch3: beagle-0.2.1-spew.patch
ExcludeArch: s390
ExcludeArch: s390x

# Mono only available on these:
ExclusiveArch: %ix86 x86_64 ppc ia64 armv4l sparc s390 s390x

%description
A general infrastructure for making your data easy to find. 

%package -n libbeagle
Summary:      Beagle C interface
Group:        Development/Libraries

%description -n libbeagle
Library to talk to the beagle server in C.

%package -n libbeagle-devel
Summary:      Beagle C interface
Group:        Development/Libraries
Requires:     libbeagle = %{version} libxml2-devel glib2-devel

%description -n libbeagle-devel
Library to talk to the beagle server in C.

%package -n libbeagle-python
Summary:      Beagle python interface
Group:        Development/Libraries
Requires:     libbeagle = %{version}
Requires:     python

%description -n libbeagle-python
Python wrappers for libbeagle

%prep
%setup -q
%patch2 -p1 -b .crawl
%patch3 -p1 -b .spew

%build
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}
%configure 
make %{?_smp_mflags}

# Generate the beagle.xpi for mozilla/firefox
pushd .
cd mozilla-extension
make
popd

%install
rm -rf $RPM_BUILD_ROOT
export MONO_SHARED_DIR=%{_builddir}/%{?buildsubdir}

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/var/cache/beagle/indexes

# Add an autostart file so beagled gets run by default
# (temporarily disabled)
#mkdir -p $RPM_BUILD_ROOT/etc/xdg/autostart
#cp %{SOURCE1} $RPM_BUILD_ROOT/etc/xdg/autostart

# TODO: Isn't there a better place to install this?
install -m 644 mozilla-extension/beagle.xpi $RPM_BUILD_ROOT%{_libdir}/beagle/

desktop-file-install --vendor gnome --delete-original		\
  --dir $RPM_BUILD_ROOT%{_datadir}/applications			\
  --add-category X-Red-Hat-Base					\
  --add-only-show-in=GNOME                                      \
  $RPM_BUILD_ROOT%{_datadir}/applications/beagle-search.desktop

desktop-file-install --vendor gnome --delete-original		\
  --dir $RPM_BUILD_ROOT%{_datadir}/applications			\
  --add-category X-Red-Hat-Base					\
  --remove-category Utility                                     \
  --add-only-show-in=GNOME                                      \
  $RPM_BUILD_ROOT%{_datadir}/applications/beagle-settings.desktop

echo "NoDisplay=true" >> $RPM_BUILD_ROOT%{_datadir}/applications/gnome-beagle-search.desktop

sed -i -e 's@Icon=tango-system-search@Icon=gnome-search-tool@' $RPM_BUILD_ROOT%{_datadir}/applications/gnome-beagle-search.desktop

%find_lang %{name}

rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/beagle/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.la

chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*/*.dll
chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*.dll
chmod a+x $RPM_BUILD_ROOT%{_libdir}/beagle/*.exe

%post -n libbeagle -p /sbin/ldconfig

%postun -n libbeagle -p /sbin/ldconfig

%pre
%define beagle_user_uid 58

/usr/sbin/groupadd -g %{beagle_user_uid} -r beagleindex 2> /dev/null || :
/usr/sbin/useradd -r -u %{beagle_user_uid} -s /sbin/nologin -c "User for Beagle indexing" -d /var/cache/beagle -g beagleindex beagleindex 2> /dev/null || :

%post 
if rpm -q firefox > /dev/null; then
# install the firefox extension
# note that this code is duplicated below in a trigger
  latest=`rpm --query --queryformat "%{VERSION}\n" firefox | head -1 | tr -d "\n\r"`
  if [ -d %{_libdir}/firefox-$latest/extensions ]; then
    cd %{_libdir}/firefox-$latest/extensions
    mkdir beagle-extension
    unzip -q -d beagle-extension %{_libdir}/beagle/beagle.xpi
    id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
    if [ -e "$id" ]; then
      rm -rf beagle-extension
    else
      mv beagle-extension "$id"
    fi
  fi
fi
%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- firefox
# install the firefox extension
latest=`rpm --query --queryformat "%{VERSION}\n" firefox | head -1 | tr -d "\n\r"`
if [ -d /usr/lib64/firefox-$latest/extensions ]; then
  libdir=/usr/lib64
else
  libdir=/usr/lib
fi
if [ -f $libdir/beagle/beagle.xpi ]; then
  cd $libdir/firefox-$latest/extensions
  mkdir beagle-extension
  unzip -q -d beagle-extension $libdir/beagle/beagle.xpi
  id=`grep em:id beagle-extension/install.rdf | head -1 | sed -e 's/^ *//' -e "s/<[^<]*>//g" | tr -d "\n\r"`
  if [ -e "$id" ]; then
    rm -rf beagle-extension
  else
    mv beagle-extension "$id"
  fi
fi

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc COPYING README
%{_sysconfdir}/cron.daily/*
%config(noreplace) %{_sysconfdir}/beagle
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/pkgconfig/beagle*.pc
%{_libdir}/beagle
%{_datadir}/beagle
%{_datadir}/pixmaps/*
%{_datadir}/applications/*
%{_mandir}/*/*
%dir %attr(-,beagleindex,beagleindex) /var/cache/beagle
%dir %attr(-,beagleindex,beagleindex) /var/cache/beagle/indexes
#%{_sysconfdir}/xdg/autostart/beagle.desktop

%files -n libbeagle
%defattr(-, root, root)
%{_libdir}/libbeagle.so.*

%files -n libbeagle-devel
%defattr(-, root, root)
%{_includedir}/libbeagle
%{_libdir}/libbeagle.so
%{_libdir}/pkgconfig/libbeagle*.pc

%files -n libbeagle-python
%{_libdir}/python*/site-packages/beagle.so

%changelog
* Thu Jun 15 2006 Jesse Keating <jkeating@redhat.com> - 0.2.6-1.fc5.5
- disable building on s390(x), mono no worky there.
- Import missing BRs from fc6 package

* Thu Jun 15 2006 Ray Strode <rstrode@redhat.com> - 0.2.6-1.fc5.2
- turn on debug spew if debug spew is enabled (bug 195621)

* Tue May  2 2006 Alexander Larsson <alexl@redhat.com> - 0.2.6-1.fc5.1
- update to 0.2.6

* Fri Apr 21 2006 Alexander Larsson <alexl@redhat.com> - 0.2.5-1.fc5.1
- update to 0.2.5
- Contains fix for command line injection security problem (#189282)

* Fri Apr  7 2006 Matthias Clasen <mclasen@redhat.com> 0.2.4-1.fc5.1
- Update to 0.2.4
- Update patches

* Tue Mar 21 2006 Alexander Larsson <alexl@redhat.com> 0.2.3-5
- Rebuild fc5 update in rawhide

* Tue Mar 21 2006 Alexander Larsson <alexl@redhat.com> - 0.2.3-4
- Remove more instances of wrapper scripts starting apps in cwd.
  Fixes bug #185981, and CVE-2006-1296

* Fri Mar 17 2006 Ray Strode <rstrode@redhat.com> - 0.2.3-3
- use /sbin/nologin instead of /bin/nologin for beagle user
  shell

* Fri Mar 17 2006 Ray Strode <rstrode@redhat.com> - 0.2.3-2
- use /bin/nologin instead of /bin/false for beagle user
  shell

* Fri Mar 17 2006 Ray Strode <rstrode@redhat.com> - 0.2.3-1
- Update to 0.2.3

* Wed Mar  8 2006 Ray Strode <rstrode@redhat.com> - 0.2.2-3
- turn off beagle by default to limit the severity of
  bug 183898
- fix trigger/post scriptlet (bug 184238) 

* Tue Mar  7 2006 Alexander Larsson <alexl@redhat.com> - 0.2.2-2
- Fix beagle-craw-system NullPtrException

* Tue Mar  7 2006 Alexander Larsson <alexl@redhat.com> - 0.2.2-1
- update to 0.2.2

* Fri Mar  3 2006 Alexander Larsson <alexl@redhat.com> 0.2.1-17
- Change beagle user to uid/gid 58 (registered), because
  nut was already using 57 (unregistred!)

* Wed Mar  1 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-15
- Bump log level to "error" to avoid tons of
  pointless warnings. (#183162)

* Wed Mar  1 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-14
- Fix a typo in /etc/beagle/crawl-applications

* Wed Mar  1 2006 Ray Strode <rstrode@redhat.com> 0.2.1-13
- add patch from  Felipe Alfaro Solana <felipe_alfaro@linuxmail.org>
  to invote beagle indexing helper function with valid shell
  (bug 183360)

* Fri Feb 24 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-12
- Remove more "run from ." nonsense  (#182709)
- Don't spew tons of debug output  (#182660)
- Try to make the trigger more robust  (#182679)

* Wed Feb 22 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-11
- Silence %%post 

* Wed Feb 22 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-10
- Fix %%post for 64bit arches

* Tue Feb 21 2006 Matthias Clasen <mclasen@redhat.com> 0.2.1-8
- Autostart beagled by default
- Use anacron
- Install the firefox extension
- Add a trigger to reinstall the firefox extension 
  on firefox updates
- Adapt crawl-rules to Fedora

* Fri Feb 17 2006 Karsten Hopp <karsten@redhat.de> 0.2.1-7
- add BuildRequires

* Wed Feb 15 2006 Alexander Larsson <alexl@redhat.com> 0.2.1-6
- Make all dlls executable to correctly pick up dependencies

* Mon Feb 13 2006 Ray Strode <rstrode@redhat.com> - 0.2.1-4
- remove preferences from accessories menu
- hide holmes (gnome-panel shows it in places now)
- change holmes icon to one we have

* Sun Feb 12 2006 Christopher Aillon <caillon@redhat.com> - 0.2.1-4
- Update sqlite3.patch so that it behaves better with sqlite2 and 3

* Fri Feb 10 2006 Alexander Larsson <alexl@redhat.com> - 0.2.1-3
- Correctly allocate uid/gid

* Tue Feb  7 2006 Matthias Clasen <mclasen2redhat.com> - 0.2.1-2
- Add missing BuildRequires (#180336)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 0.2.1-1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Tue Jan 31 2006 Christopher Aillon <caillon@redhat.com> 0.2.1-1
- Update to beagle 0.2.1
- Use sqlite3 instead of sqlite2

* Tue Jan 31 2006 Ray Strode <rstrode@redhat.com> 0.2.0-4 
- don't blindly run beagled in current working directory 
  (bug 177675)

* Tue Jan 24 2006 Than Ngo <than@redhat.com> 0.2.0-3 
- added --add-only-show-in=gnome to the desktop-file-install calls
 
* Tue Jan 24 2006 Than Ngo <than@redhat.com> 0.2.0-2
- beagle-settings/beagle-search only show in gnome

* Sun Jan 22 2006 Alexander Larsson <alexl@redhat.com> - 0.2.0-1
- update to 0.2.0

* Wed Jan 18 2006 Ray Strode <rstrode@redhat.com> - 0.1.4-4
- depend on poppler for pdf utilities instead of xpdf 
  (bug 177446)

* Wed Jan 11 2006 Alexander Larsson <alexl@redhat.com> - 0.1.4-3
- Rebuild with fixed evolution-sharp

* Mon Jan  9 2006 Alexander Larsson <alexl@redhat.com> - 0.1.4-2
- Don't package libbeagle twice

* Mon Jan  9 2006 Alexander Larsson <alexl@redhat.com> - 0.1.4-1
- Update to 0.1.4
- Add mono 1.1.12.1 patch

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Dec  8 2005 Alexander Larsson <alexl@redhat.com> - 0.1.3-1
- update to 0.1.3

* Wed Nov 23 2005 Alexander Larsson <alexl@redhat.com> - 0.1.2-2
- Fix evolution backend library loading

* Fri Nov 18 2005 Alexander Larsson <alexl@redhat.com> - 0.1.2-1
- Initial version
